<!-- 选择设备（选择的是受检设备） -->
<script lang="ts" setup name="SelectEquipmentDialog">
import { ElMessage } from 'element-plus'
import type { Ref } from 'vue'
import { ref } from 'vue'
import dayjs from 'dayjs'
import type { DateModelType } from 'element-plus'
import type { TableColumn } from '@/components/NormalTable/table_interface'
import { getEquipmentList } from '@/api/business/manager/order'

const emits = defineEmits(['confirm'])
const dialogFormVisible = ref(false) // 控制对话框显隐
const isMulti = ref(false)// 表格是否多选
// 查询条件
const listQuery = ref({
  equipmentNo: '', // 统一编号
  equipmentName: '', // 设备名称
  customerId: '', // 委托方id
  formId: '', // 表单id
  manufactureNo: '', // 出厂编号
  traceCompany: '', // 溯源单位
  certificateValidStart: '', // 证书有效期(开始)
  certificateValidEnd: '', // 证书有效期(结束)
  equipmentType: '1', // 1受检设备;2特种设备
  offset: 1,
  limit: 20,
})
const dateRange = ref<[DateModelType, DateModelType]>(['', ''])// 筛选时间段数据
const checkoutList = ref([]) // 多选选中的内容
const loadingTable = ref(false) // 表格loading
const list = ref([]) as any // 表格数据
const total = ref(0) // 数组总数
const columns = ref<TableColumn[]>([
  { text: '统一编号', value: 'equipmentNo', align: 'center', width: '160' },
  { text: '设备名称', value: 'equipmentName', align: 'center' },
  { text: '型号规格', value: 'model', align: 'center' },
  { text: '生产厂家', value: 'manufacturer', align: 'center' },
  { text: '出厂编号', value: 'manufactureNo', align: 'center' },
  { text: '负责人', value: 'directorName', align: 'center' },
  { text: '使用状态', value: 'usageStatusName', align: 'center', width: '90' },
  { text: '检定日期', value: 'checkDate', align: 'center', width: '120' },
  { text: '证书有效期', value: 'certificateValid', align: 'center', width: '120' },
])

// 数据查询
function fetchData(isNowPage = false) {
  listQuery.value.limit = isMulti.value ? 20 : 5
  loadingTable.value = true
  if (!isNowPage) {
    // 是否显示当前页，否则跳转第一页
    listQuery.value.offset = 1
  }
  getEquipmentList(listQuery.value).then((response) => {
    list.value = response.data.rows.map((item: { checkDate: string; certificateValid: string }) => {
      return {
        ...item,
        checkDate: item.checkDate ? dayjs(item.checkDate).format('YYYY-MM-DD') : item.checkDate, // 检定日期
        certificateValid: item.certificateValid ? dayjs(item.certificateValid).format('YYYY-MM-DD') : item.certificateValid, // 证书有效期
      }
    })
    total.value = parseInt(response.data.total)
    loadingTable.value = false
  })
}
// 重置
const clearList = () => {
  listQuery.value = {
    equipmentNo: '', // 统一编号
    equipmentName: '', // 设备名称
    customerId: '', // 委托方id
    formId: '', // 表单id
    manufactureNo: '', // 出厂编号
    traceCompany: '', // 溯源单位
    certificateValidStart: '', // 证书有效期(开始)
    certificateValidEnd: '', // 证书有效期(结束)
    equipmentType: '1', // 1受检设备;2特种设备
    offset: 1,
    limit: 20,
  }
  dateRange.value = ['', '']
  fetchData()
}
// 搜索
const search = () => {
  fetchData(true)
}
// 多选选中
const handleSelectionChange = (val: any) => {
  checkoutList.value = val
}
// 页数发生变化后的操作，可能是页码变化，可能是每页容量变化，此函数必写
const changePage = (val: { size?: number; page?: number }) => {
  if (val && val.size) {
    listQuery.value.limit = val.size
  }
  if (val && val.page) {
    listQuery.value.offset = val.page
  }
  search()
}
// 点击确定
const confirmSelect = () => {
  if (!checkoutList.value.length) {
    ElMessage.warning('请选择设备')
  }
  else {
    emits('confirm', checkoutList.value)
    dialogFormVisible.value = false
  }
}
// 取消
const resetForm = () => {
  dialogFormVisible.value = false
  clearList()
}
/**
 * 初始化
 * @param isMultiParam 是否多选
 * @param getCustomerId 委托方id
 */
const initDialog = (isMultiParam: boolean, getCustomerId: string) => {
  isMulti.value = isMultiParam // 是否多选
  dialogFormVisible.value = true // 显示对话框
  listQuery.value.customerId = getCustomerId // 委托方id
  console.log('isMultiParam', isMultiParam)
  fetchData()
}
// ----------------------------------------------钩子------------------------------------------------------
watch(dateRange, (val) => {
  if (val) {
    listQuery.value.certificateValidStart = `${val[0]}`
    listQuery.value.certificateValidEnd = `${val[1]}`
  }
  else {
    listQuery.value.certificateValidStart = ''
    listQuery.value.certificateValidEnd = ''
  }
})
defineExpose({ initDialog })
</script>

<template>
  <el-dialog v-if="dialogFormVisible" v-model="dialogFormVisible" title="选择设备" width="65%">
    <!-- 筛选条件 -->
    <search-area :need-clear="true" @search="search" @clear="clearList">
      <search-item>
        <el-input v-model.trim="listQuery.equipmentNo" placeholder="统一编号" class="short-input" clearable />
      </search-item>
      <search-item>
        <el-input v-model.trim="listQuery.equipmentName" placeholder="设备名称" class="short-input" clearable />
      </search-item>
      <search-item>
        <el-date-picker
          v-model="dateRange"
          class="short-input"
          type="daterange"
          range-separator="至"
          format="YYYY-MM-DD"
          value-format="YYYY-MM-DD"
          start-placeholder="检定有效期(开始)"
          end-placeholder="检定有效期(结束)"
        />
      </search-item>
    </search-area>

    <!-- 查询结果Table显示 -->
    <div style="padding: 12px;">
      <normal-table
        :data="list"
        :total="total"
        :columns="columns"
        :query="listQuery"
        is-showmulti-select
        :list-loading="loadingTable"
        :is-multi="isMulti"
        :height="260"
        :page-sizes="isMulti ? [20] : [5]"
        @change="changePage"
        @multi-select="handleSelectionChange"
      >
        <!-- 序号 -->
        <template #preColumns>
          <el-table-column label="#" width="55" align="center" fixed>
            <template #default="scope">
              {{ (listQuery.offset - 1) * listQuery.limit + scope.$index + 1 }}
            </template>
          </el-table-column>
        </template>
      </normal-table>
    </div>
    <template #footer>
      <span class="dialog-footer">
        <el-button type="primary" @click="confirmSelect">确认</el-button>
        <el-button @click="resetForm">
          取消
        </el-button>
      </span>
    </template>
  </el-dialog>
</template>

<style lang="scss" scoped>
:deep(.el-radio__label) {
  display: none;
}
</style>
